Thursday, October 25, 2018

Leetcode 403. Frog Jump

A frog is crossing a river. The river is divided into x units and at each unit there may or may not exist a stone. The frog can jump on a stone, but it must not jump into the water.
Given a list of stones' positions (in units) in sorted ascending order, determine if the frog is able to cross the river by landing on the last stone. Initially, the frog is on the first stone and assume the first jump must be 1 unit.
If the frog's last jump was k units, then its next jump must be either k - 1, k, or k + 1 units. Note that the frog can only jump in the forward direction.
Note:
  • The number of stones is ≥ 2 and is < 1,100.
  • Each stone's position will be a non-negative integer < 231.
  • The first stone's position is always 0.
Example 1:
[0,1,3,5,6,8,12,17]

There are a total of 8 stones.
The first stone at the 0th unit, second stone at the 1st unit,
third stone at the 3rd unit, and so on...
The last stone at the 17th unit.

Return true. The frog can jump to the last stone by jumping 
1 unit to the 2nd stone, then 2 units to the 3rd stone, then 
2 units to the 4th stone, then 3 units to the 6th stone, 
4 units to the 7th stone, and 5 units to the 8th stone.
Example 2:
[0,1,2,3,4,8,9,11]

Return false. There is no way to jump to the last stone as 
the gap between the 5th and 6th stone is too large.

Analysis:
The problem is a classic sequence DP problem. The only trick is we need to define the dp function in a special way: 
dp[i] defines all the possible steps jumps to stone i. So each element of the dp[i] is a list, which stores all the steps from previous stone j. 

So for all previous stone[j], we check if we can reach from stone j to stone i. If yes, we store the steps between stone i and stone j. 

So why not just store the maximal distance between stone j and i. That is, if we can reach stone i in 10 steps, we must reach in 1 - 9 steps? That's wrong. It's because for each jump, we can only move dp[j] - 1, to dp[j] + 1 steps. 

Code (Java):
class Solution {
    public boolean canCross(int[] stones) {
        List<Integer>[] dp = (List<Integer>[]) new ArrayList[stones.length];
        for (int i = 0; i < stones.length; i++) {
            dp[i] = new ArrayList<>();
        }
        dp[0].add(0);

        for (int i = 1; i < stones.length; i++) {
            for (int j = 0; j < i; j++) {
                for (Integer pos : dp[j]) {
                    if (stones[i] >= stones[j] + pos - 1 && 
                        stones[i] <= stones[j] + pos + 1) {
                        dp[i].add(stones[i] - stones[j]);
                        break;
                    }
                }
            }
        }
        
        return !dp[stones.length - 1].isEmpty();
    }
}

No comments:

Post a Comment